博客
关于我
强烈建议你试试无所不能的chatGPT,快点击我
【leetcode】1035. Uncrossed Lines
阅读量:6757 次
发布时间:2019-06-26

本文共 2095 字,大约阅读时间需要 6 分钟。

题目如下:

We write the integers of A and B (in the order they are given) on two separate horizontal lines.

Now, we may draw connecting lines: a straight line connecting two numbers A[i] and B[j] such that:

  • A[i] == B[j];
  • The line we draw does not intersect any other connecting (non-horizontal) line.

Note that a connecting lines cannot intersect even at the endpoints: each number can only belong to one connecting line.

Return the maximum number of connecting lines we can draw in this way.

 

Example 1:

Input: A = [1,4,2], B = [1,2,4]Output: 2Explanation: We can draw 2 uncrossed lines as in the diagram.We cannot draw 3 uncrossed lines, because the line from A[1]=4 to B[2]=4 will intersect the line from A[2]=2 to B[1]=2.

Example 2:

Input: A = [2,5,1,2,5], B = [10,5,2,1,5,2]Output: 3

Example 3:

Input: A = [1,3,7,1,7,5], B = [1,9,2,5,1]Output: 2

 

Note:

  1. 1 <= A.length <= 500
  2. 1 <= B.length <= 500
  3. 1 <= A[i], B[i] <= 2000

解题思路:本题可以采用动态规划的方法。记dp[i][j]为A[i]与B[j]连线后可以组成的最多连线的数量,当然这里A[i]与B[j]连线是虚拟的连线,因此存在A[i] != B[j]的情况。首先来看A[i] == B[j],这说明A[i]与B[i]可以连线,显然有dp[i][j] = dp[i-1][j-1]+1;如果是A[i] != B[j],那么分为三种情况dp[i][j] = max(dp[i-1][j-1],dp[i][j-1],dp[i-1][j]),这是因为A[i]不与B[j]连线,但是A[i]可能可以与B[j]之前所有点的连线,同理B[j]也是一样的。

代码如下:

class Solution(object):    def maxUncrossedLines(self, A, B):        """        :type A: List[int]        :type B: List[int]        :rtype: int        """        dp = []        for i in range(len(A)):            dp.append([0] * len(B))        for i in range(len(A)):            for j in range(len(B)):                if A[i] == B[j]:                    dp[i][j] = max(dp[i][j],1)                    if i - 1 >= 0 and j - 1 >= 0 :                        dp[i][j] = max(dp[i][j],dp[i-1][j-1]+1)                else:                    if i - 1 >= 0 and j - 1 >= 0:                        dp[i][j] = max(dp[i][j],dp[i-1][j-1])                    if j - 1 >= 0:                        dp[i][j] = max(dp[i][j],dp[i][j-1])                    if i - 1 >= 0:                        dp[i][j] = max(dp[i][j],dp[i-1][j])        return dp[-1][-1]

 

转载于:https://www.cnblogs.com/seyjs/p/10901340.html

你可能感兴趣的文章
python3学习笔记(二):Python初识
查看>>
Servlet 文件上传
查看>>
数据库设计
查看>>
递归分析 普及组【2010】三4 C++版
查看>>
JQ - 绑定(on)/解绑(off)事件(浅显的见解)
查看>>
JavaScript setInterval(定时/延时调用函数)
查看>>
Quartz.NET 任务调度教程。
查看>>
华为oj之字符串反转
查看>>
数据访问
查看>>
JSP里面的虚拟目录
查看>>
【329】word 替换文本高级用法
查看>>
微信开发相关资源
查看>>
ubantu root 默认密码
查看>>
自动化测试用例编写原则
查看>>
crontab定时任务以及其中中文乱码问题
查看>>
JsonCpp 判断 value 中是否有某个KEY
查看>>
Java基础11
查看>>
中国嵌入式工控机市场前景广阔
查看>>
Mysql 行列转换
查看>>
函数模板的使用说明
查看>>